/* Created automatically by dinodoc.pl from dinotrace.txt */

char dinodoc[] = "\
This file documents the Dinotrace package for viewing signal waveforms.\n\
\n\
  Copyright 1998-2011 by Wilson Snyder. <wsnyder@wsnyder.org>\n\
\n\
  Permission is granted to make and distribute verbatim copies of this\n\
manual provided the copyright notice and this permission notice are\n\
preserved on all copies.\n\
\n\
  Permission is granted to copy and distribute modified versions of this\n\
manual under the conditions for verbatim copying, provided that the\n\
entire resulting derived work is distributed under the terms of a\n\
permission notice identical to this one.\n\
\n\
  Permission is granted to copy and distribute translations of this\n\
manual into another language, under the above conditions for modified\n\
versions, except that this permission notice may be stated in a\n\
translation approved by the author.\n\
\n\
  This file documents the Dinotrace package for signal waveform tracing.\n\
This is edition 9.4c, for Dinotrace version 9.4c.\n\
\n\
  For the latest version, please see `http://www.veripool.org/dinotrace'\n\
\n\
  Please feel free to send comments and suggestions to\n\
<wsnyder@wsnyder.org>.  If you install this tool, please also send mail\n\
so that I can inform you of new releases.\n\
\n\
1 Summary\n\
*********\n\
\n\
Dinotrace is a tool designed to aid in viewing Verilog Value Change\n\
"
"Dump, ASCII, Verilator, Tempest CCLI, COSMOS, Chango and Decsim Binary\n\
simulation traces.  It is optimized for rapid design debugging using\n\
X-Windows Mosaic.  A special interface allows signal information to be\n\
annotated into source code using Emacs.\n\
\n\
  Please see the file `INSTALL' in the distribution directory for\n\
installation instructions.\n\
\n\
1.1 Copying\n\
===========\n\
\n\
Dinotrace is free software; you can redistribute it and/or modify it\n\
under the terms of the GNU General Public License as published by the\n\
Free Software Foundation; either version 3, or (at your option) any\n\
later version.\n\
\n\
  Dinotrace is distributed in the hope that it will be useful, but\n\
*without any warranty*; without even the implied warranty of\n\
*merchantability* or *fitness for a particular purpose*.  See the GNU\n\
General Public License for more details.\n\
\n\
  You should have received a copy of the GNU General Public License\n\
along with Dinotrace; see the file `COPYING'.  If not, write to the Free\n\
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA\n\
02111-1307, USA.\n\
\n\
2 History\n\
*********\n\
\n\
Dinotrace was conceived in the early 1980's by Allen Gallotta at Digital\n\
Equipment Corporation, who wrote the code and supported it through\n\
"
"version 4.2.  When created, it was the first graphical display tool for\n\
the simulators being designed at Digital.\n\
\n\
  In 1992 I joined Digital Semiconductor (a division of Digital\n\
Equipment Corporation) and took over the support of Dinotrace.  I\n\
converted it from Digital's X toolkit to Motif, added color,\n\
highlighting, searching, and other features.  Several formats were\n\
added to Dinotrace to support Verilator, our group's own Verilog to C\n\
translator, written by Paul Wasson.  As the years went on, other groups\n\
started using the typical industry standard Verilog simulators.\n\
Although programs like vwaves were available, they had some silly\n\
limitations.  Besides, we were hooked on Dinotrace, so I added Verilog\n\
format, and Dinotrace lived on.\n\
\n\
  In 1998 I moved to Maker Communications, where I am currently\n\
employed.  Life, however, was sad and incomplete without Dinotrace.\n\
Through the efforts of existing DECies, mainly Duane Galbi, Digital\n\
graciously agreed to release the source code.  (Subject to the code not\n\
being resold, which is compatible with the GNU Public License.)\n\
\n\
  Still at Maker Communications, life is now complete as Dinotrace can\n\
be shared by all.  This release is based upon the Digital version, with\n\
many enhancements, most notably portability improvements and true\n\
4-state signal support.\n\
\n\
2.1 Contributors\n\
================\n\
\n\
Many people have provided ideas and other assistance with Dinotrace.\n\
\n\
  The major corporate sponsors of Dinotrace, by providing funds or\n\
"
"equipment grants, are Compaq Corporation, Digital Equipment Corporation,\n\
Intel Corporation, and Maker Communications.\n\
\n\
  The people who have contributed code or other major functionality are\n\
Allen Gallotta, Steve Hoover, Nathan Hughes, and Craig Ziegler.\n\
\n\
  Some of the people who have provided ideas and feedback for Dinotrace\n\
include Edward Arthur, Sally Barry, Josh Belkin, Yifat Ben-Shachar, Lee\n\
Bradshaw, Rachel Berman, Sass Berman, Mike Blake, Serge Bogdanov, Ronen\n\
Boneh, Gregg Bouchard, Derek Bosch, Bill Bruce, Lauren Carlson, Paul\n\
Chan, Ta-Chung Chang, David Chen, Dave Colson, Derrick Dacosta, Erik\n\
Debriae, Paul Dormitzer, Duane Galbi, Allen Gallotta, Steve Glaser,\n\
Mike Goulet, Larry Gust, Larry Herman, Dave Horan, Steve Hoover, Nathan\n\
Hughes, Tom Hunt, Tracey Jones, Mike Kagen, Dan Katz, Sol Katzman,\n\
Steve Kolecki, Steve Lang, Charlie Lind, Greg Loxtercamp, Dan Lussier,\n\
Ben Marshall, Bob McNamara, Harunobu Miyashita, John Murphy, Aki\n\
Niimura, Lisa Noack, Mitch Norcross, Michael Quadri, Reinhard Schumann,\n\
Simcha, Jai Singh, Dean Sovie, Julie Staraitis, Dominik Strasser, Bob\n\
Walsh, Paul Wasson, Steve Wilson, Bob Yodlowski, and Craig Ziegler.\n\
\n\
3 Invoking Dinotrace\n\
********************\n\
\n\
Dinotrace accepts switches and filenames on the command line.  Any\n\
filenames on the command line will be read in before Dinotrace gives\n\
control to the user.\n\
\n\
  Dinotrace accepts switches with leading `-', and everything else is a\n\
trace filename.  Filenames are in standard Unix format, with a optional\n\
`.gz' or `.Z' extension to indicate the trace should be piped before\n\
opening through *gunzip* or *uncompress* respectively.\n\
"
"\n\
  These switches are supported, in addition to the standard *X-11*\n\
switches, like `-display'.\n\
\n\
`-verilog'\n\
     Read following trace filenames using Verilog format.  This is the\n\
     default format.\n\
\n\
`-vpd'\n\
     Read following trace filenames using Verilog Plus Dump format.\n\
\n\
`-decsim'\n\
     Read following trace filenames using Decsim format.  If running on\n\
     a VMS system, Decsim Binary format is also supported.\n\
\n\
`-tempest'\n\
     Read following trace filenames using Tempest/CCLI format.\n\
\n\
`-noconfig'\n\
     Skip reading the standard global, user, and directory .dino files.\n\
     Do read any trace-specific .dino files.\n\
\n\
`-geometry GEOMETRY'\n\
     Specifies the window size and position in standard X format\n\
     (WIDTHXHEIGHT+XPOS+YPOS).\n\
\n\
`-res RESOLUTION'\n\
     Specify the trace resolution.\n\
\n\
\n\
4 Screen Description\n\
"
"********************\n\
\n\
This chapter describes the layout of the screen, and the function of the\n\
various widget and menu items.\n\
\n\
4.1 Window Widgets\n\
==================\n\
\n\
The main window is broken into the display area, with signal names on\n\
the left and values stretching to the vertical scroll bar.\n\
\n\
  The state of each signal across time is indicated by the way the line\n\
is drawn.  As usual, low, tristate, and high are low, middle, and high\n\
strait lines.  The high value has a bolder line to aid in discriminating\n\
it from a low.  Unknowns are filled areas.\n\
\n\
  Busses are drawn in one of four ways; if zero they are low, if all\n\
bits are one it it is two parallel lines with the upper one bolded.  If\n\
the bus is some mix of zeros and ones it is two narrow parallel lines.\n\
If there is space the value of the bus will be shown based on the\n\
`Signal Radix' menu option.  Finally, the `Signal Waveform' allows\n\
analog waveforms, or signed waveforms (two's complement with 0 making a\n\
centered trace.)\n\
\n\
  Gadgets surround the main area.  The vertical scroll bar on the right\n\
is the _Signal Slider_ used to scroll signals, if they all cannot fit\n\
on the screen at once.  At the bottom of the screen is the _Time\n\
Slider_ on the right, and the _Name Slider_ on the left.\n\
\n\
4.1.1 Time Slider\n\
-----------------\n\
"
"\n\
On the left bottom of the main window is the _Time Slider_.\n\
\n\
_Drag_\n\
     Dragging the _Time Slider_ will scroll the time across the screen.\n\
     Lines are printed in the scroll area to indicate where cursors are\n\
     located.\n\
\n\
_Unit Dec_\n\
     Clicking the <- arrow at the left of the _Time Slider_, or\n\
     pressing `<left>' will move the time one grid #0 (or the first\n\
     visible grid) resolution earlier.\n\
\n\
_Unit Inc_\n\
     Clicking the -> arrow at the right of the _Time Slider_, or\n\
     pressing `<right>' will move the time one grid #0 resolution\n\
     (usually one clock) later.\n\
\n\
_Page Dec_\n\
     Clicking the blank area at the left of the _Time Slider_, or\n\
     pressing `S-<right>' will move the time one screen width earlier,\n\
     so the time at the left of the screen is now at the right.  (Or\n\
     1/2 or 1/4 screen width, depending on the `page_inc' customization\n\
     setting.)\n\
\n\
_Page Inc_\n\
     Clicking the blank area at the right of the _Time Slider_, or\n\
     pressing `S-<right>' will move the time one screen width later, so\n\
     the time at the right of the screen is now at the left. (Or 1/2 or\n\
     1/4 screen width, depending on the `page_inc' customization\n\
     setting.)\n\
"
"\n\
4.1.2 Name Slider\n\
-----------------\n\
\n\
The _Name Slider_ is the horizontal scroll bar left of the _Time\n\
Slider_.\n\
\n\
_Drag_\n\
     Dragging the _Name Slider_ will scroll the signal names left and\n\
     right so that they may be completely seen.  Dinotrace aligns the\n\
     signals on the last dot (hierarchy character).\n\
\n\
\n\
4.1.3 Signal Slider\n\
-------------------\n\
\n\
The _Signal Slider_ is the vertical scroll bar to the right of the\n\
window.\n\
\n\
_Drag_\n\
     Dragging the _Signal Slider_ will scroll the signals so that new\n\
     signals can be seen.  Lines are printed in the scroll area to\n\
     indicate where highlighted signals are located.\n\
\n\
_Unit Dec_\n\
     Clicking the <- arrow at the top of the _Signal Slider_, or\n\
     pressing `<up>' will move the signals down one, displaying a new\n\
     signal at the top.\n\
\n\
_Unit Inc_\n\
     Clicking the -> arrow at the bottom of the _Signal Slider_, or\n\
"
"     pressing `<down>' will move the Moves signals up one, displaying a\n\
     new signal at the bottom.\n\
\n\
_Page Dec_\n\
     Clicking the blank area above the _Signal Slider_, or pressing\n\
     `<pageup>' will move the signals up one screen full, so the\n\
     previous top signal is now at the bottom.\n\
\n\
_Page Inc_\n\
     Clicking the blank area below the _Signal Slider_, or pressing\n\
     `<pagedown>' will move the signals down one screen full, so the\n\
     previous bottom signal is now at the top.\n\
\n\
\n\
4.1.4 Buttons\n\
-------------\n\
\n\
The buttons below the lower sliders perform common functions that affect\n\
the display.\n\
\n\
_Begin_\n\
     Clicking the _Begin_ button below the _Time Slider_, or pressing\n\
     `<begin>' will move to the earliest time in the trace.\n\
\n\
_End_\n\
     Clicking the _End_ button below the _Time Slider_, or pressing\n\
     `<end>' will move to the earliest time in the trace.\n\
\n\
_Goto_\n\
     Clicking the _Goto_ button below the _Time Slider_, or pressing\n\
     `g' will make a popup that prompts for a time.  The window will\n\
"
"     scroll horizontally so that the entered time is centered on the\n\
     screen.  A option menu will place a cursor of the selected color\n\
     at the time entered.  A note may be attached to the cursor, and\n\
     seen with `Value Examine'.\n\
\n\
_Refresh_\n\
     Clicking the _Refresh_ button below the scroll bar will refresh\n\
     the screen.  Normally this is automatic.  When using Dinotrace\n\
     over slow links, it may be desirable to refresh manually, *Note\n\
     refreshing::.\n\
\n\
_Resolution_\n\
     Clicking the _Resolution_ number button at the middle bottom will\n\
     make a popup that can change the resolution to the number\n\
     specified.\n\
\n\
_Inc Res_\n\
     Clicking the arrow button to the right of the _Resolution_ button\n\
     expands the trace so the same amount of time takes more space.\n\
\n\
_Dec Res_\n\
     Clicking the arrow button to the left of the _Resolution_ button\n\
     expands the trace so the same amount of time takes less space.\n\
\n\
_Zoom_\n\
     Clicking the _Zoom_ button, then clicking `<MB1>' on two times\n\
     expands the trace so that the time between the clicks occupies the\n\
     entire screen.\n\
\n\
_Full_\n\
     Clicking the _Full_ button shrinks the resolution so that the\n\
"
"     entire trace fits onto the screen.  It is often quicker to press\n\
     _Full_ then zoom to the desired location rather than scrolling.\n\
\n\
\n\
4.2 Trace Menu\n\
==============\n\
\n\
4.2.1 Trace Read...\n\
-------------------\n\
\n\
Selecting the `Trace Read...' menu option, or pressing `C-o' pops up a\n\
file requester to read a trace.  If a file ends in a `.Z' or `.gz'\n\
extension, it will be piped through uncompress or gunzip respectively\n\
before being read.  The type of trace may be set with the option box;\n\
the default is set by the `file_format' configuration command.  If\n\
_Preserve Signal Ordering_ is checked, the signals in the new trace\n\
will be reorganized to attempt to match the ordering of the current\n\
trace in the window.\n\
\n\
4.2.2 Trace ReRead\n\
------------------\n\
\n\
Selecting `Trace ReRead' checks if there is a new version of the file\n\
currently begin displayed and reads it.  The file will only be read if\n\
a new one exists.  If no file is displayed, it is the same as the\n\
`Trace Read' option.\n\
\n\
  This is useful for rereading a trace after it has changed due to a new\n\
simulation run.\n\
\n\
4.2.3 Trace ReRead All\n\
"
"----------------------\n\
\n\
Selecting `Trace ReRead All', or pressing `C-r', checks every window to\n\
see if that window's file has been updated, and rereads if it has.\n\
\n\
4.2.4 Trace Open...\n\
-------------------\n\
\n\
Selecting `Trace Open...' shrinks the current window in half, and opens\n\
another Dinotrace window, linked in time to the original.  The two\n\
traces will then pan together and share cursors, etc.  Multiple window\n\
support is intended for traces that have the same time lengths.  See\n\
*note open_geometry:: for how to change the default window sizes, such\n\
as to not shrink the original window when opening.\n\
\n\
4.2.5 Trace Close\n\
-----------------\n\
\n\
Selecting `Trace Close' closes the current window if more than one is\n\
open.  If this is the only one remaining open, use `Trace Exit' instead.\n\
\n\
4.2.6 Trace Clear\n\
-----------------\n\
\n\
Selecting `Trace Clear' closes all other windows and resets Dinotrace\n\
as if Dinotrace was exited and ran again.\n\
\n\
4.2.7 Trace Print...\n\
--------------------\n\
\n\
Selecting `Trace Print...' pops up a file requester allowing the\n\
"
"current screen to be printed to a file.  The amount of time, and number\n\
of signals on the screen will match the time and signals put onto one\n\
page of paper.\n\
\n\
  The _Filename_ and _Note_ specify where to put the output, and a note\n\
to be placed on the bottom of each page.\n\
\n\
  The _Layout_ option selects the size of the page.  _EPS_ will make a\n\
Encapsulated Postscript file that does not include all of the headers.\n\
This is suitable for making figures for inclusion in other documents.\n\
\n\
  The _Include off-screen times_ button will print multiple\n\
\"horizontal\" pages of paper, so that all times in the trace is printed.\n\
The _Include off-screen signals_ button will print multiple \"vertical\"\n\
pages, so that all signals are printed.  Both may be checked and taped\n\
together to get a nice wall hanging.\n\
\n\
  The _Begin printing at_ and _End printing at_ select the region to be\n\
printed.  This may be based on the whole trace, what is displayed on\n\
the screen, or the cursors.\n\
\n\
4.2.8 Trace Print\n\
-----------------\n\
\n\
Selecting `Trace Print' performs a print using the last `Trace\n\
Print...' settings.\n\
\n\
4.2.9 Trace Exit\n\
----------------\n\
\n\
Selecting `Trace Exit' will exit Dinotrace.\n\
"
"\n\
4.3 Customize Menu\n\
==================\n\
\n\
4.3.1 Customize Change...\n\
-------------------------\n\
\n\
Selecting `Customize Change' pops up a requester that allows the\n\
configuration to be customized.  See *note Customization Files:: for\n\
permanent configuration, and additional options that are not selectable\n\
here.\n\
\n\
  The _Page Increment_ option selects how much of a screen clicking on\n\
the _Page Inc_ space on the _Time Slider_ will increment.\n\
\n\
  The _Time Representation_ option selects how times are displayed and\n\
entered in the _Goto_ popup.  Selecting _Grid #0 Cycles_ will put all\n\
times in the period defined by Grid #0.\n\
\n\
  The _Signal Height_ option controls how many signals can fit on the\n\
screen and printout.  Small sizes have more information, but may cause\n\
the values to be hard to read.\n\
\n\
  The _Click To Edge_ button enables `Cursor Add' and other menu items\n\
that require mouse clicks to find the closest transition and add it at\n\
that point.  The search will be only within 20 pixels; if there is no\n\
edge within that distance, the cursor is added right where the cursor\n\
is.\n\
\n\
  The _Rise/Fall Time_ slider controls how fast signals transition.\n\
\n\
"
"  Thw _Draw Prefix_ enables displaying the entire signal name, instead\n\
of the default where a prefix common to every signal in the design is\n\
not shown.\n\
\n\
  Thw _Manual Refreshing_ button disables automatic refreshing, for\n\
dialup lines.  The _Refresh_ button must be pressed to refresh the\n\
screen.\n\
\n\
4.3.2 Customize Grid...\n\
-----------------------\n\
\n\
Selecting `Customize Grid' pops up a requester that allows the\n\
configuration to be customized.  See *note Customization Files:: for\n\
permanent configuration.  Note that the lowest numbered grid that is\n\
visible is used for moving one increment, stepping cursors forward and\n\
back, and for counting cycles.\n\
\n\
4.3.3 Customize Read...\n\
-----------------------\n\
\n\
Selecting `Customize Read' pops up a requester that reads the specified\n\
`.dino' file.  The requester also allows enabling and disabling of\n\
which `.dino' files will be read when a new trace is read.\n\
\n\
4.3.4 Customize ReRead\n\
----------------------\n\
\n\
Selecting `Customize ReRead' will reread the customize `.dino' files.\n\
This is useful for applying changes to Dinotrace after a `.dino' file\n\
has been edited outside Dinotrace.\n\
\n\
"
"4.3.5 Customize Save As...\n\
--------------------------\n\
\n\
Selecting `Customize Save As...' will create a popup.  A filename may\n\
then be entered to save the current customization settings.  Buttons\n\
allow different portions of the configuration to be written.  Note that\n\
many of the settings that will be saved can be applied only to one\n\
window, and should be edited out before being included in any global\n\
`dinotrace.dino' files.\n\
\n\
4.3.6 Customize Restore\n\
-----------------------\n\
\n\
Selecting `Customize Restore' will restore the customization options to\n\
their program defaults.  It will not read any `.dino' files.\n\
\n\
4.4 Cursor Menu\n\
===============\n\
\n\
4.4.1 Cursor Add\n\
----------------\n\
\n\
Selecting `Cursor Add', or pressing `c', then clicking `<MB1>' will\n\
insert cursors at the clicked on times.  The `Next' color button, or\n\
pressing `C' will select the next color down in the menu from the last\n\
color selected.  See *note cursor_add:: for the equivalent\n\
configuration file command.\n\
\n\
4.4.2 Cursor Highlight\n\
----------------------\n\
\n\
"
"Selecting `Cursor Delete' then clicking `<MB1>' on cursors will change\n\
the color of those cursors.\n\
\n\
4.4.3 Cursor Move\n\
-----------------\n\
\n\
Selecting `Cursor Move' then Dragging `<MB1>' on a cursor will move\n\
that cursor.  Press and hold mouse button one and release when the\n\
cursor is at the new time desired.  Moving a cursor that was created\n\
with `Signal Search' will make that cursor permanent; the cursor will\n\
not go away if the search is changed.\n\
\n\
4.4.4 Cursor Delete\n\
-------------------\n\
\n\
Selecting `Cursor Delete' then clicking `<MB1>' on cursors will delete\n\
those cursors.  To delete cursors that were created by `Value Search'\n\
(those with dotted lines), turn off the second button on the `Value\n\
Search' requester.\n\
\n\
4.4.5 Cursor Note\n\
-----------------\n\
\n\
Selecting `Cursor Note' then clicking `<MB1>' on a cursor will pop up a\n\
dialog box to change the note attached to that cursor.\n\
\n\
4.4.6 Cursor Step Forward\n\
-------------------------\n\
\n\
Selecting `Cursor Step Forward' or pressing `>' will move all user\n\
cursors forward the by grid #0's (or the first visible grid's) period.\n\
"
"\n\
4.4.7 Cursor Step Backward\n\
--------------------------\n\
\n\
Selecting `Cursor Step Back' or pressing `<' will move all user cursors\n\
backward the by grid #0's (or the first visible grid's) period.\n\
\n\
4.4.8 Cursor Clear\n\
------------------\n\
\n\
Selecting `Cursor Clear' will delete all cursors.\n\
\n\
4.4.9 Cursor Cancel\n\
-------------------\n\
\n\
Selecting `Cursor Cancel', or pressing `<esc>' will stop `<MB1>' mouse\n\
clicks from having any affect.\n\
\n\
4.5 Signal Menu\n\
===============\n\
\n\
4.5.1 Signal Add...\n\
-------------------\n\
\n\
Selecting `Signal Add' will pop up a popup allowing a signal to be\n\
selected then added at the point where `<MB1>' is clicked.  See *note\n\
signal_add:: for the equivalent configuration file command.\n\
\n\
4.5.2 Signal Highlight\n\
----------------------\n\
\n\
"
"Selecting `Signal Highlight', or pressing `s', then clicking `<MB1>' on\n\
signals changes the color of those signals.  See *note\n\
signal_highlight:: for the equivalent configuration file command.\n\
\n\
4.5.3 Signal Move\n\
-----------------\n\
\n\
Selecting `Signal Move' then clicking `<MB1>' on a signal and clicking\n\
`<MB1>' again on a new position moves a signal.  Signals may be moved\n\
between traces, but closing a trace eliminates all signals that were\n\
originally from that trace.  See *note signal_move:: for the equivalent\n\
configuration file command.\n\
\n\
4.5.4 Signal Copy\n\
-----------------\n\
\n\
Selecting `Signal Copy' then clicking `<MB1>' on a signal and clicking\n\
`<MB1>' again on a new position copies a signal.  Signals may be copied\n\
between traces, but closing a trace eliminates all signals that were\n\
originally from that trace.  See *note signal_copy:: for the equivalent\n\
configuration file command.\n\
\n\
4.5.5 Signal Delete\n\
-------------------\n\
\n\
Selecting `Signal Delete' then clicking `<MB1>' on signals deletes\n\
those signals.  `Signal Select' may be used to recover the deleted\n\
signals.  See *note signal_delete:: for the equivalent configuration\n\
file command.\n\
\n\
4.5.6 Signal Note\n\
"
"-----------------\n\
\n\
Selecting `Signal Note' then clicking `<MB1>' on a signal will pop up a\n\
dialog box to change the note attached to that signal.\n\
\n\
4.5.7 Signal Radix\n\
------------------\n\
\n\
Selecting `Signal Radix' then clicking `<MB1>' on signals changes the\n\
radix of the signals to the one selected.  Note that the `real' radix\n\
is detected for Verilog automatically, and changing other non-real\n\
signals to a real format probably won't display the values you wish.\n\
See *note signal_radix:: for the equivalent configuration file command.\n\
\n\
4.5.8 Signal Waveform\n\
---------------------\n\
\n\
Selecting `Signal Waveform' then clicking `<MB1>' on signals changes\n\
the signal to be displayed as either analog or digital.  See *note\n\
signal_waveform:: for the equivalent configuration file command.\n\
\n\
4.5.9 Signal Search...\n\
----------------------\n\
\n\
Selecting `Signal Search' opens a popup for highlighting signal names.\n\
Nine signal names which will be searched for in the trace are\n\
specified.  Any signal name which matches the signal name pattern will\n\
be highlighted using the color of the toggle button, just as if `Signal\n\
Highlight' was used to color it.  Unlike `Signal Search', highlighting\n\
a signal with `Signal Highlight' makes it permanent; it will not go\n\
away when the search that found that signal changes.\n\
"
"\n\
  The _Signal name pattern_ indicates which signal names to highlight,\n\
potentially containing `*' to match any number of characters, or `?' to\n\
match any single character.  Case never matters when matching signal\n\
names.\n\
\n\
  The _Enable_ button enables the search, and shows the color to be\n\
used for highlighting when the signal is found.\n\
\n\
4.5.10 Signal Select...\n\
-----------------------\n\
\n\
Selecting `Signal Select', or pressing `C-f', presents a requester\n\
which lists the names of the signals which are being displayed, and\n\
those which are deleted.  Both lists have a pattern at the top which a\n\
signal must match to be displayed.  Clicking on a signal will add it to\n\
the bottom of the other list.  Clicking on the _Add All_ or _Delete\n\
All_ will affect all of those in the list.  By specifying a pattern\n\
then _Add All_ or _Delete All_, signals which match a pattern can be\n\
added or deleted.\n\
\n\
  The _Delete Constants_ button will delete only those signals which\n\
have a single constant value for all times in the trace.  Likewise the\n\
_Delete Const or X/Z_ button will delete only those signals which have\n\
a constant value, or are unknown or tristated.  This is useful for\n\
deleting those signals which have uninitialized values before reset\n\
then later in the trace are initalized to constants.\n\
\n\
  The _Sort Wholename_ and _Sort Basename_ buttons will sort the\n\
selected signals and place them at the bottom of the trace.  The former\n\
uses the entire signal name, while the latter sorts by the basename,\n\
"
"ignoring the hierarchy portion of the signal name.\n\
\n\
4.5.11 Clear Highlight\n\
----------------------\n\
\n\
Selecting `Signal Clear Highlight' will remove all highlighting from\n\
signals.\n\
\n\
4.5.12 Keep Highlight\n\
---------------------\n\
\n\
Selecting `Signal Keep Highlighted' will delete signals from the trace\n\
which are not highlighted.  This allows signals to be highlighed that\n\
match a given pattern using _Signal Select..._, then all others deleted\n\
using this selection.\n\
\n\
4.5.13 Signal Cancel\n\
--------------------\n\
\n\
Selecting `Signal Cancel', or pressing `<esc>' will stop `<MB1>' mouse\n\
clicks from having any affect.\n\
\n\
4.6 Value Menu\n\
==============\n\
\n\
4.6.1 Value Annotate...\n\
-----------------------\n\
\n\
Selecting `Value Annotate...' makes a file with the highlighted\n\
signals, and values under every cursor.  Behavioral code can then be\n\
highlighted with the values by `dinotrace.el''s reading the written\n\
"
"file.  Cursors which are exactly on a edge of a signal will get the\n\
value that the signal is changing _to_, not from.\n\
\n\
  Buttons specify which cursor and signal colors are included in the\n\
file.  If a button is on, the color is included, else it is as if the\n\
cursor did not exist, or the signal was not highlighted.\n\
\n\
  User cursors are those placed using the `Cursor Add' menu.  Automatic\n\
cursors are from searching for values or cursors placed by `.dino'\n\
files.\n\
\n\
  See *note Dinotrace and Emacs::\n\
\n\
4.6.2 Value Annotate\n\
--------------------\n\
\n\
Selecting `Value Annotate', or pressing `a' annotates code using the\n\
last Annotate... settings.  See *note annotate:: for the equivalent\n\
configuration file command.\n\
\n\
4.6.3 Value Highlight\n\
---------------------\n\
\n\
Selecting `Value Highlight', or pressing `v', then clicking `<MB1>' on\n\
a value loads that value into one of the 9 search values, and\n\
highlights it where it occurs in the trace.  The search value can then\n\
be seen and modified with the `Value Search' popup.  See *note\n\
value_highlight:: for the equivalent configuration file command.\n\
\n\
4.6.4 Value Examine\n\
-------------------\n\
"
"\n\
Selecting `Value Examine' then holding `<MB1>' will show the state of\n\
the entity under the mouse.  `<MB2>' can always be used for this\n\
feature.\n\
\n\
  Signal transitions can be examined when over the transition lines.\n\
Signal names and base information can be seen when over the signal\n\
names.  Cursors can be examined when at the bottom of the screen, and\n\
grids when at the top.\n\
\n\
4.6.5 Value Search...\n\
---------------------\n\
\n\
Selecting `Value Search...' allows specification of 9 values to be\n\
searched for in the trace.  Each value is entered into a text widget and\n\
one or two toggle buttons to the left are activated.  The `Value\n\
Highlight' menu can be used to load a search automatically.  See *note\n\
value_highlight:: for the equivalent configuration file command.\n\
\n\
  The _Highlight value_ button will make anywhere that the value\n\
appears in a trace to be printed using the color of the toggle button.\n\
\n\
  The _Add cursor_ button will add a cursor at the time where the value\n\
begins.  Cursors that are placed in this fashion are displayed as\n\
dotted lines, and will go away if the search value is changed.\n\
Highlighting or moving a cursor makes it permanent; it will not go away\n\
when the search changes.\n\
\n\
  The _Signal name pattern_ indicates which signals names to search for\n\
the value, potentially containing `*' to match any number of\n\
characters, or `?' to match any single character.  Often a single `*'\n\
"
"is useful to search all signals.\n\
\n\
  The _Value_ indicates the value to be found.  Unfortunately wildcards\n\
are not supported.  A standard verilog or VHDL prefix may be added to\n\
specify the radix of the number being entered.  (The radix of the\n\
signal found does not have to match the radix entered; `'h10' will\n\
match `'d16'.\n\
\n\
`'h<num>'\n\
`X\"<num>\"'\n\
     Hex\n\
\n\
`'o<num>'\n\
`O\"<num>\"'\n\
     Octal\n\
\n\
`'b<num>'\n\
`B\"<num>\"'\n\
     Binary\n\
\n\
`'d<num>'\n\
`D\"<num>\"'\n\
     Decimal\n\
\n\
`'r<num>'\n\
`R\"<num>\"'\n\
     Real\n\
\n\
`'s<strg>'\n\
\n\
`S\"<strg>\"'\n\
"
"\n\
`\"<strg>\"'\n\
     Ascii (String)\n\
\n\
4.6.6 Value Cancel\n\
------------------\n\
\n\
Selecting `Value Cancel', or pressing `<esc>' will stop `<MB1>' mouse\n\
clicks from having any affect.\n\
\n\
5 Keyboard Shortcuts\n\
********************\n\
\n\
This chapter describes the keyboard shortcuts for Dinotrace.\n\
\n\
  Any menu function may be invoked with the standard Motif accelerators;\n\
hold down `<ALT>' then press the first letter of the menu name.\n\
Release `<ALT>' and press the underlined letter of the sub menu item,\n\
and so on.\n\
\n\
  The following keys are also hard-coded: Function keys have the\n\
identical function when using GNU Emacs's Verilog, C, Merlin, or CCLI\n\
modes.\n\
\n\
`<MB2>'\n\
     `Value Examine'.\n\
\n\
`<up>'\n\
     Signal scroll up one signal.\n\
\n\
`S-<up>'\n\
"
"     Signal scroll up a screen full.\n\
\n\
`<down>'\n\
     Signal scroll down one signal.\n\
\n\
`S-<down>'\n\
     Signal scroll down a screen full.\n\
\n\
`<pageup>'\n\
     Signal scroll up a screen full.\n\
\n\
`<pagedown>'\n\
     Signal scroll down a screen full.\n\
\n\
`<left>'\n\
     Time scroll left a grid #0 increment.\n\
\n\
`S-<left>'\n\
     Time scroll left a screen full.\n\
\n\
`<right>'\n\
     Time scroll left a grid #0 increment.\n\
\n\
`S-<right>'\n\
     Time scroll left a screen full.\n\
\n\
`<begin>'\n\
     Beginning of time.\n\
\n\
`<end>'\n\
     End of time.\n\
"
"\n\
`<esc>'\n\
     `Signal Cancel'.\n\
\n\
`>'\n\
     `Cursor Step Forward'.\n\
\n\
`<'\n\
     `Cursor Step Backward'.\n\
\n\
`a'\n\
     `Value Annotate'.\n\
\n\
`c'\n\
     `Cursor Add' with current color.\n\
\n\
`C'\n\
     `Cursor Add' with next color.\n\
\n\
`g'\n\
     _Goto_ time.\n\
\n\
`s'\n\
     `Signal Highlight' with current color.\n\
\n\
`S'\n\
     `Signal Highlight' with next color.\n\
\n\
`v'\n\
     `Value Highlight' with current color.\n\
\n\
"
"`V'\n\
     `Value Highlight' with next color.\n\
\n\
`C-f'\n\
     `Signal Search...'.\n\
\n\
`C-o'\n\
     `Trace Read...'.\n\
\n\
`C-r'\n\
     `Trace ReRead All'.\n\
\n\
\n\
6 Customization Files\n\
*********************\n\
\n\
This chapter describes customization files, and the commands that may\n\
be used in them.\n\
\n\
  Customization files allow the options and display in Dinotrace to be\n\
customized to suit a specific site, user, directory, and trace.\n\
\n\
6.1 Automatically Read Files\n\
============================\n\
\n\
When a trace file is read using the `Trace Read' menu option, several\n\
configuration files are read automatically:\n\
\n\
`$DINODISK:dinotrace.dino'\n\
     The `$DINODISK:dinotrace.dino' file is intended to have site wide\n\
     defaults.  This will probably contain a `file_format verilog' or\n\
"
"     similar commands.  (On Unix, `$DINODISK' represents the contents of\n\
     the `DINODISK' environment variable.  On VMS, it represents the\n\
     value of the system define.)\n\
\n\
`$DINOCONFIG'\n\
     The `$DINOCONFIG' file is intended to be used for session specific\n\
     start-up, like setting screen size depending on what type of\n\
     system you are using.  Users will probably point this to several\n\
     possible sources using their `.login'.\n\
\n\
`~/dinotrace.dino'\n\
     The `~/dinotrace.dino' file is for user defaults.  The author for\n\
     example has a `signal_height 15' and `signal_delete_constant *',\n\
     which are both personal preference items.  (On VMS, `SYS$LOGIN:'\n\
     is used instead of `~/'.)\n\
\n\
`{current/trace/directory}/dinotrace.dino'\n\
     The `{current/trace/directory}/dinotrace.dino' is for signal_states\n\
     and other information on a per-simulation setup basis.  This\n\
     probably includes `signal_state' commands (unless they are in the\n\
     global dinotrace.dino).\n\
\n\
`{current/trace/directory}/CURRENT_TRACE_NAME.dino'\n\
     The `{current/trace/directory}/CURRENT_TRACE_NAME.dino' is for\n\
     highlighting and such that only apply to the current file.  See the\n\
     enclosed example *Perl* script that will parse a log file for times\n\
     that errors occurred and write a dino that places a cursor at\n\
     every such time.\n\
\n\
\n\
6.2 Configuration Commands\n\
"
"==========================\n\
\n\
Configuration files are organized with one command per line, with the\n\
exception of `signal_states', which may be multiple lines.  Case is\n\
ignored in all but state names.  The commands are:\n\
\n\
6.2.1 #\n\
-------\n\
\n\
`#'	COMMENT\n\
\n\
  Comments out the remainder of the line.\n\
\n\
6.2.2 page_inc\n\
--------------\n\
\n\
`page_inc'		4 | 2 | 1\n\
\n\
  Changes the increment used during _Page Inc_ and _Page Dec_ clicks on\n\
the horizontal scroll-bar.  1=full page, 2=half, 4=quarter.  Same as\n\
the page option menu in `Customize Change'.\n\
\n\
6.2.3 rise_fall_time\n\
--------------------\n\
\n\
`rise_fall_time'	NUMBER\n\
\n\
  Changes the slope used when drawing signal assertions and deassertion.\n\
Use 0 to minimize the `rise_fall_time'.\n\
\n\
6.2.4 signal_height\n\
"
"-------------------\n\
\n\
`signal_height'	NUMBER\n\
\n\
  Changes the vertical spacing between signals on the screen.  Same as\n\
the slider in `Customize Change'.\n\
\n\
6.2.5 grid\n\
----------\n\
\n\
`grid'		GRID_NUMBER       ON | OFF\n\
\n\
  Enables or disables the grid.  Same as the visible toggle buttons in\n\
`Customize Grid'.\n\
\n\
6.2.6 grid_resolution\n\
---------------------\n\
\n\
`grid_resolution'	GRID_NUMBER       NUMBER | AUTO | EDGE\n\
\n\
  Changes the horizontal space between grids, normally the period of a\n\
clock.  Specify a number in nanoseconds, or `AUTO' to compute the grid\n\
based on the `grid_signal'.  Use `EDGE' to place a grid on each change\n\
of the `grid_signal'.\n\
\n\
6.2.7 grid_align\n\
----------------\n\
\n\
`grid_align'	GRID_NUMBER       NUMBER | ASSERTION | DEASSERTION |\n\
BOTH\n\
\n\
"
"  Changes the horizontal location of the first grid mark.  Specify a\n\
number in nanoseconds, `ASSERTION' to align with the asserting edge of\n\
the `grid_signal', or `DEASSERTION' to align with the deasserting edge\n\
of the `grid_signal', or `BOTH' to align with both edges of the\n\
`grid_signal'.  The grid may also align with changes in a bus, although\n\
in that case `ASSERTION' and `DEASSERTION' have the same effect.\n\
\n\
6.2.8 grid_signal\n\
-----------------\n\
\n\
`grid_signal'	GRID_NUMBER	PATTERN\n\
\n\
  Specifies which signal is to be used when calculating the period and\n\
alignment with grid_resolution and grid_alignment respectively.  The\n\
first signal that matches the pattern is used, it defaults to `\"*\"',\n\
which is the first signal in the trace.  If no signal is found that\n\
matches the pattern, that grid will be disabled.\n\
\n\
6.2.9 grid_type\n\
---------------\n\
\n\
`grid_type'	PATTERN	NORMAL | WIDE\n\
\n\
  Specifies normal grids, or extra wide grids.  Wide grids are plotted 2\n\
pixels wide, and help low-contrast colors show up better.\n\
\n\
6.2.10 grid_color\n\
-----------------\n\
\n\
`grid_color'	GRID_NUMBER	COLOR\n\
\n\
"
"  Changes the color used to display the grid.\n\
\n\
6.2.11 refreshing\n\
-----------------\n\
\n\
`refreshing'		AUTO | MANUAL\n\
\n\
  In automatic refresh mode, any change in the screen such as zooming,\n\
Dragging, or exposing refreshes (redraws) the screen.  When set to\n\
manual the screen will only redraw when the refresh gadget is pressed.\n\
Note that when in manual mode, it is just as if the display _was_\n\
refreshed, so for example clicking on the display is relative to the\n\
_new_ display. Useful when using slow network links, such as dialup *eXcursion*\n\
or *exceed*.\n\
\n\
6.2.12 refresh\n\
--------------\n\
\n\
`refresh'\n\
\n\
  Refresh the screen, even if in manual refresh mode.  When a `.dino'\n\
file is being read, the screen will not be refreshed until the entire\n\
file is completely read, unless a `refresh' command is used.\n\
\n\
6.2.13 draw_prefix\n\
------------------\n\
\n\
`draw_prefix'\n\
\n\
  By default, a prefix common to every signal in the design is not shown\n\
in the main window.  With this setting, the signal name will be shown in\n\
"
"it's entirety.\n\
\n\
6.2.14 annotate\n\
---------------\n\
\n\
`annotate'\n\
\n\
  Makes the annotation file, like the `Value Annotate' menu.\n\
\n\
6.2.15 resolution\n\
-----------------\n\
\n\
`resolution'		NUMBER\n\
\n\
  Sets the screen resolution, like the _Resolution_ Button on the\n\
bottom of the screen.\n\
\n\
6.2.16 save_enables\n\
-------------------\n\
\n\
`save_enables'	ON | OFF\n\
\n\
  When reading in verilator CCLI traces, Dinotrace converts two-state\n\
enables and data signals into a single four-state signal, then deletes\n\
the original signals.  When `save_enables' is on, the original signals\n\
are not deleted.  This is useful for debugging problems related to\n\
tristating.\n\
\n\
6.2.17 save_duplicates\n\
----------------------\n\
\n\
"
"`save_duplicates'	ON | OFF\n\
\n\
  When reading in verilog traces, Dinotrace by default drops signals\n\
that connect to a signal higher in the hierarchy.  This saves space and\n\
reduces clutter.  When `save_duplicates' is on, the duplicate signals\n\
are not deleted, except under rare situations.\n\
\n\
6.2.18 save_ordering\n\
--------------------\n\
\n\
`save_ordering'	ON | OFF\n\
\n\
  When set, Dinotrace will attempt to preserve signal colors, ordering,\n\
and deletions between the trace that existed before and the new trace\n\
being read in.  Signals that were deleted because they were constants\n\
are not preserved, they will be recalculated.  When clear, the new trace\n\
does not preserve any ordering information.\n\
\n\
6.2.19 signal_goto\n\
------------------\n\
\n\
`signal_goto'		SIGNAL\n\
\n\
  Move the window so that signal is in the center of the window.  If the\n\
signal was already on the screen, do nothing.\n\
\n\
6.2.20 time_goto\n\
----------------\n\
\n\
`time_goto'		TIME\n\
\n\
"
"  Move the window so that time is in the center of the window.  If time\n\
was already on the screen, do nothing.\n\
\n\
6.2.21 time_rep\n\
---------------\n\
\n\
`time_rep'		NUMBER | FS | PS | NS | US | CYCLE\n\
\n\
  Changes the time representation to be in picoseconds, nanoseconds,\n\
microseconds or in number of grid #0 cycles.  Cycle based timing is good\n\
for performance estimates.  Same as the buttons in `Customize Change'.\n\
If a number, then that number is the baseline in picoseconds.  For\n\
example, `2000' will make one unit on the screen be equal to 2 ns in\n\
the trace file.  Default is nanoseconds.\n\
\n\
6.2.22 time_precision\n\
---------------------\n\
\n\
`time_precision'	FS | PS | NS | US\n\
\n\
  Changes the internal precision to be in picoseconds, nanoseconds, or\n\
microseconds.  Traces that are read in will have all times rounded to\n\
this number.  Setting to higher units requires less memory and speeds up\n\
execution.  This parameter must only be changed in the global or user\n\
`dinotrace.dino' files, as it should not change between reading\n\
different traces.  Default is nanoseconds.\n\
\n\
  Only Decsim Binary and Verilog formats contain absolute time periods,\n\
and these will be scaled by the precision.  Decsim Ascii traces are\n\
always assumed to be in nanoseconds.  The Tempest format will be assumed\n\
to be in the same units as the `time_precision', and will not be scaled.\n\
"
"\n\
6.2.23 time_format\n\
------------------\n\
\n\
`time_format'		%0.6lf | %0.6lg | %lg | \"\"\n\
\n\
  Changes the number of decimal places used to print times.  This format\n\
string is the same as that used by the C-Language printf command.  (See\n\
`man printf' or `HELP CC RUN PRINTF'.) Some of the useful choices are\n\
`%0.6lf' which will print 6 decimal places with trailing zeros\n\
(123.450000), `%0.6lg' which will print up to 6 decimal places\n\
(123.45), and `%lg' which will print the number of decimal places\n\
required to fully show the number.\n\
\n\
  The default is null (\"\").  When null time_precision and time_rep will\n\
set the preferred format for time stamps.  For example, setting\n\
`time_precision PS' and `time_rep NS' will make times display as\n\
\"nn.ppp ns\" where n is the nanoseconds, and p is the picoseconds.\n\
\n\
6.2.24 time_divisor\n\
-------------------\n\
\n\
`time_divisor'	NUMBER\n\
\n\
  When reading Ascii traces, all times are divided by this number.\n\
Generally the time_precision is what is wanted instead, as\n\
time_precision doesn't change the internal times but instead the\n\
display. Time_divisor changes the value that is read in from the file,\n\
and is most useful for Ascii traces which do not specify any time units\n\
in the file itself.\n\
\n\
"
"6.2.25 time_multiplier\n\
----------------------\n\
\n\
`time_multiplier'	NUMBER\n\
\n\
  When reading Tempest traces, the multiplier will be used to convert\n\
the phase counter to the time.  Defaults to 2.\n\
\n\
6.2.26 file_format\n\
------------------\n\
\n\
`file_format'		DECSIM | TEMPEST | VERILOG | VPD\n\
\n\
  Changes the file format to be read.  Same as the buttons in the\n\
`Trace Open' menu.\n\
\n\
6.2.27 cursor\n\
-------------\n\
\n\
`cursor'		ON | OFF\n\
\n\
  Enables or disables the cursors.  Same as the toggle buttons in\n\
`Customize Change'.\n\
\n\
6.2.28 cursor_add\n\
-----------------\n\
\n\
`cursor_add'	TIME COLOR [-USER] [COMMENT]\n\
\n\
  Adds a cursor of color number COLOR (0 to 9) at the specified time.\n\
If specified, add COMMENT that may be seen with `Value Examine'.  The\n\
"
"cursor will be dotted, and will disappear the next time a file is read\n\
in.  The `-USER' flag makes the cursor like a manual cursor; it will be\n\
a solid line and will not disappear on rereads.\n\
\n\
6.2.29 click_to_edge\n\
--------------------\n\
\n\
`click_to_edge'	ON | OFF\n\
\n\
  Enables or disables whether adding a cursor or grid close to a signal\n\
edge will place the cursor on that edge.\n\
\n\
6.2.30 debug\n\
------------\n\
\n\
`debug'		ON | OFF\n\
\n\
  Enables or disables debugging mode.\n\
\n\
6.2.31 print\n\
------------\n\
\n\
`print'		NUMBER | ON | OFF\n\
\n\
  Enables or disables debugging print mode at the specified\n\
informational level.\n\
\n\
6.2.32 print_size\n\
-----------------\n\
\n\
`print_size'		A | B | EPSPORT | EPSLAND\n\
"
"\n\
  Selects the paper size, A (8 1/2\" by 11\") or B (11\" by 17\").\n\
`EPSPORT' and `EPSLAND' make an Encapsulated Postscript file without\n\
headers, in portrait or landscape layout, suitable for inclusion in\n\
other documents.\n\
\n\
  Same as the buttons in the `Trace Print' popup.\n\
\n\
6.2.33 vector_separator\n\
-----------------------\n\
\n\
`vector_separator'	\"CHARACTER\"\n\
\n\
  Sets the character that separates the base signal name from vector\n\
numbers.  The default is `[', which means that the signal `alpha[1]'\n\
consists of vector number 1 in the signal named alpha.  Three other\n\
useful combinations are `_' for spider signals `alpha_1', `<' for\n\
Decsim signals `alpha<1>', and null (\"\") for no separator `alpha1'.  If\n\
the separator is null (\"\") then `<' will still be accepted.  Tempest\n\
traces are assumed to use the `<' separator, and setting it otherwise\n\
will split up all of the bits into individual entries.\n\
\n\
6.2.34 start_geometry\n\
---------------------\n\
\n\
`start_geometry'	WIDTHxHEIGHT+XOFFSET+YOFFSET\n\
\n\
  Specifies the geometry to be used when the first window is opened by\n\
Dinotrace.  Specified in standard X-Windows format, for example\n\
`start_geometry 1200x900+20+95' specifies a window at position 20, 95\n\
of width 1200 and height 900.\n\
"
"\n\
6.2.35 open_geometry\n\
--------------------\n\
\n\
`open_geometry'	WIDTH[%]xHEIGHT[%]+XOFFSET[%]+YOFF[%]\n\
\n\
  Specifies the geometry to be used when a new trace window is created\n\
with `Trace Open' menu.  The format may be the same as\n\
`start_geometry', in which case the exact dimensions specified will be\n\
used for the new window.  Percentage may be used to specify a position\n\
and size relative to the old window.  For example the default is\n\
`open_geometry 100%x50%+0%+50%' which means that the new window will\n\
have the same width and half the height of the old window.  The\n\
position will be the same in the x direction and 50% more (not 50% of\n\
the value) in the y direction.\n\
\n\
6.2.36 shrink_geometry\n\
----------------------\n\
\n\
`shrink_geometry'	WIDTH%xHEIGHT%+XOFFSET%+YOFF%\n\
\n\
  Specifies the geometry to be used when a old trace window is being\n\
shrunk with `Trace Open' menu option.  Absolute positions should not be\n\
used, instead percentages should be used to specify a position and size\n\
relative to the original window size.  For example the default is\n\
`shrink_geometry 100%x50%+0%+0%' which means that when the new opened\n\
window is created the old window will have the same width, X, and Y\n\
position, but half the height of the old window.\n\
\n\
6.2.37 value_highlight\n\
----------------------\n\
"
"\n\
`value_highlight' VALUE COLOR [SIGNAL_PATTERN] -COLOR -CURSOR\n\
\n\
  Searches for the value in signals matching the pattern.  If the\n\
`-COLOR' flag is set, changes the color of the value to COLOR (0 to 9).\n\
If the `-CURSOR' flag is set, adds a cursor of the specified COLOR. The\n\
signal_pattern is the name of the signal inside the trace, with <*>\n\
being a wild card that matches any number of characters.\n\
\n\
6.2.38 signal_highlight\n\
-----------------------\n\
\n\
`signal_highlight'       SIGNAL_PATTERN   COLOR\n\
\n\
  Changes the color of any signals matching SIGNAL_PATTERN to the given\n\
color number COLOR (0 to 9).  The signal_pattern is the name of the\n\
signal inside the trace, with <*> being a wild card that matches any\n\
number of characters.\n\
\n\
6.2.39 signal_add\n\
-----------------\n\
\n\
`signal_add'		SIGNAL_PATTERN [AFTER_SIGNAL] [COLOR]\n\
\n\
  Adds signals matching SIGNAL_PATTERN from the trace, if the signal was\n\
deleted.  If the signal hasn't been deleted, nothing happens.  If the\n\
AFTER_SIGNAL is provided, the signal is added after the first signal\n\
that matches the AFTER_SIGNAL pattern.  If AFTER_SIGNAL is not\n\
provided, the new signal is added to the end of the trace.\n\
\n\
6.2.40 signal_delete\n\
"
"--------------------\n\
\n\
`signal_delete'	SIGNAL_PATTERN\n\
\n\
  Deletes signals matching SIGNAL_PATTERN from the trace.\n\
\n\
6.2.41 signal_delete_constant\n\
-----------------------------\n\
\n\
`signal_delete_constant'	SIGNAL_PATTERN [-IGNOREXZ]\n\
\n\
  Deletes signals matching the pattern, which have a constant value,\n\
from the trace.  If `-IGNOREXZ' is specified, don't consider transitions\n\
to/from unknown or tristate as making a signal non-constant.  Useful for\n\
reducing a large number of signals down to only those which change.\n\
\n\
6.2.42 signal_copy\n\
------------------\n\
\n\
`signal_copy'		SIGNAL_PATTERN [AFTER_SIGNAL] [COLOR]\n\
\n\
  Copies signals matching SIGNAL_PATTERN from the trace to a new\n\
position.  If the AFTER_SIGNAL is provided, the signal is added after\n\
the first signal that matches the AFTER_SIGNAL pattern.  If\n\
AFTER_SIGNAL is not provided or is not found, the new signal is added\n\
to the end of the trace.\n\
\n\
6.2.43 signal_move\n\
------------------\n\
\n\
`signal_move'		SIGNAL_PATTERN [AFTER_SIGNAL] [COLOR]\n\
"
"\n\
  Move signals matching SIGNAL_PATTERN to a new position.  If the\n\
AFTER_SIGNAL is provided, the signal is moved after the first signal\n\
that matches the AFTER_SIGNAL pattern.  If AFTER_SIGNAL is not\n\
provided, the new signal is added to the end of the trace.\n\
\n\
6.2.44 signal_note\n\
------------------\n\
\n\
`signal_note'		SIGNAL_PATTERN NOTE\n\
\n\
  Add the specified note to signals matching SIGNAL_PATTERN.  The\n\
signal note may be viewed by pressing with the Examine button over the\n\
signal name.\n\
\n\
6.2.45 signal_rename\n\
--------------------\n\
\n\
`signal_rename'	SIGNAL_PATTERN NEW_SIGNAL_NAME [COLOR]\n\
\n\
  Changes the *first* signal matching SIGNAL_PATTERN to have the name\n\
NEW_SIGNAL_NAME This can be used to make a alias copy of a signal by\n\
copying a signal, then renaming it.\n\
\n\
6.2.46 signal_radix\n\
-------------------\n\
\n\
`signal_radix'	SIGNAL_PATTERN RADIX\n\
\n\
  Changes signals matching SIGNAL_PATTERN to have the specified radix.\n\
Note that the `real' radix is detected for Verilog automatically, and\n\
"
"changing other non-real signals to a real format probably won't display\n\
the values you wish.\n\
\n\
6.2.47 signal_waveform\n\
----------------------\n\
\n\
`signal_waveform'	SIGNAL_PATTERN ANALOG | ANALOG_SIGNED | DIGITAL\n\
\n\
  Changes signals matching SIGNAL_PATTERN to have the specified\n\
waveform representation on the display.\n\
\n\
6.2.48 signal_states\n\
--------------------\n\
\n\
`signal_states'	SIGNAL_PATTERN = {STATE, STATE...};\n\
\n\
  Allows the value of a bus to be translated to a text string.  The\n\
SIGNAL_PATTERN is the name of the signal inside the trace, with `*'\n\
being a wild card that matches any number of characters.  Each state is\n\
the text to be displayed, using the characters `0-9A-Z%._/'.  States\n\
are assigned in numerical order starting with zero, unless a `##='\n\
proceeds a state name: If a state name is of the form `##=name', for\n\
example in `7=Read' the Read name is assigned to the bus value seven.\n\
(The number is always in decimal.)  The next assignment will be to 8 if\n\
no number is specified.\n\
\n\
  Example:\n\
\n\
     signal_states *cpucreq[2:0] = {\n\
        1=Barrier, Fetch, FetchM, Read, Write, LDx_L, STx_C};\n\
\n\
"
"  In this example, any signal ending in `cpucreq[2:0]' (any case) will\n\
convert 1 to Barrier, 2 to Fetch, etc.  Unspecified values, such as 0\n\
and 8 will be displayed as a number.  If the state does not fit on the\n\
screen, the number will be printed instead.  Text strings may only be\n\
defined for state numbers 0-255.\n\
\n\
7 X Resources\n\
*************\n\
\n\
This chapter describes the X-Windows resources that Dinotrace supports.\n\
\n\
  Dinotrace uses the X resource database for color and font selection.\n\
\n\
  To use a resource, put in your ~/.Xdefaults file\n\
     Dinotrace*Foreground: Black\n\
     Dinotrace*Background: #cacaaaaa9191\n\
     Dinotrace*color1: DarkOliveGreen\n\
\n\
  Then type at the shell `xrdb ~/.Xdefaults' to reread the database.\n\
\n\
  Dinotrace adds the following resources over and above the core X\n\
Toolkit resource names and classes (such as foreground and background):\n\
\n\
`color#'\n\
     `color#', where # is 1-9, specifies the colors for searches,\n\
     highlighting, and cursors.  color0 is fixed to the foreground\n\
     color.\n\
\n\
`barcolor'\n\
     `barcolor' specifies the color to be used for the background of\n\
     alternate signals.  Defaults to 7% greener than the background\n\
"
"     color.  Those that remember green bar tractor-feed paper should\n\
     feel comfortable with this default.\n\
\n\
`signalfont'\n\
     `signalfont' specifies the font to be used for signal names along\n\
     the sides of the trace window.  Defaults to\n\
     `-*-Fixed-Medium-R-Normal--*-120-*-*-*-*-*-1'\n\
\n\
`timefont'\n\
     `timefont' specifies the font to be used for time values along the\n\
     top of the trace window.  Defaults to\n\
     `-*-Courier-Medium-R-Normal--*-120-*-*-*-*-*-1'\n\
\n\
`valuefont'\n\
     `valuefont' specifies the font to be used for values inside buses.\n\
     Defaults to `-*-Fixed-Medium-R-Normal--*-100-*-*-*-*-*-1'\n\
\n\
\n\
8 Remote Control\n\
****************\n\
\n\
Dinotrace can be triggered to reread traces by sending a USR1 signal to\n\
it.  This allows build environments to automatically refresh dinotrace\n\
when a new waves file is available.  See the kill manpage for details on\n\
sending a signal, usually it's `kill -USR1 %?dino'.\n\
\n\
  After annotation, Emacs creates a socket that can be used to send\n\
commands into it.  See the Emacs chapter and internal code for details.\n\
\n\
9 Dinotrace and Emacs\n\
*********************\n\
"
"\n\
This chapter describes the interaction between Dinotrace and Emacs.\n\
\n\
  Dinotrace provides the means for back-annotating highlighting and\n\
values into Emacs buffers, and from Emacs, highlighting signals,\n\
values, and the like.  This is what separates Dinotrace from the rest.\n\
\n\
9.1 Installation\n\
================\n\
\n\
The appropriate Emacs code should have been installed along with the\n\
rest of Dinotrace.  If you encounter problems, you should return to this\n\
section.\n\
\n\
  You'll probably also need `verilog-mode.el' from\n\
`http://www.veripool.org/verilog-mode'.  Make sure that file, and the\n\
distribution's files `lisp/dinotrace.el' and `lisp/sim-mode.el' are\n\
installed in your Emacs `site-lisp' directory. (In Emacs `C-h v\n\
load-path <RET>' should list the name of that directory.)  Check that\n\
in your `.emacs' file, or better yet, the site's `site-start.el' file\n\
there are the lines:\n\
\n\
     (autoload 'sim-log-mode \"sim-log\" \"Mode for Simulation Log files.\" t)\n\
     (setq auto-mode-alist (append (list '(\"\\\\.log$\" . sim-log-mode)) auto-mode-alist))\n\
     (autoload 'dinotrace-update \"dinotrace\" \"Update dinotrace annotations in this buffer\" t)\n\
     (autoload 'dinotrace-mode   \"dinotrace\" \"Toggle dinotrace annotations in this buffer\" t)\n\
     (global-set-key \"\\C-x\\C-aa\" 'dinotrace-update)\n\
     (global-set-key \"\\C-x\\C-ad\" 'dinotrace-mode)\n\
\n\
9.2 Annotation\n\
==============\n\
"
"\n\
With a trace up in Dinotrace, select the `Value Annotate...' menu item.\n\
This will create a magic file in your home directory.\n\
\n\
  In Emacs, visit a Verilog or C file which has some signals that are in\n\
the trace.  Press `C-x C-a a'.  Emacs will read the annotation file and\n\
add highlighting to your buffer.  A new menu will appear on the screen,\n\
and the mode line will indicate `Dinotrace'.\n\
\n\
  In a simulation log file (ending in `.log'), Pressing `C-x C-a a'\n\
will likewise add annotations of where cursors exist.\n\
\n\
9.3 Signal Matching\n\
===================\n\
\n\
Emacs chooses what to highlight based upon only the base part of the\n\
signal name; all hierarchy and bus descriptors are stripped.  If\n\
multiple signals exist with the same basename, all signals other than\n\
those with the desired hierarchy should be deleted so they won't\n\
participate in the annotation.\n\
\n\
9.4 Entering Dinotrace-Mode\n\
===========================\n\
\n\
There are two keys used to enter Dinotrace Mode:\n\
\n\
`C-x C-a a'\n\
`M-x dinotrace-update'\n\
     `C-x C-a a' will enter dinotrace-mode in this buffer.  If there is\n\
     a new annotation file, read it, update all annotations in all\n\
     visible widows, and remove outdated annotations from invisible\n\
"
"     buffers.\n\
\n\
`C-x C-a d'\n\
`M-x dinotrace-mode'\n\
     `C-x C-a d' will toggle Dinotrace Mode in this buffer.  With arg,\n\
     turn Dinotrace mode on if and only if arg is positive.\n\
\n\
     It will not read a new annotation file if one has already been\n\
     read in.\n\
\n\
\n\
9.5 Exiting Dinotrace Mode\n\
==========================\n\
\n\
There are two ways to exit Dinotrace Mode:\n\
\n\
`C-x C-a d'\n\
`M-x dinotrace-mode'\n\
     `C-x C-a d' will toggle Dinotrace Mode in this buffer.  With zero\n\
     or negative arg, turn off Dinotrace mode.\n\
\n\
`C-x C-q'\n\
`M-x dinotrace-toggle-read-only'\n\
     `C-x C-q' will toggle read-only status.  Dinotrace traps this key\n\
     and will remove annotations and make the buffer writable.\n\
\n\
\n\
9.6 Configuring Dinotrace-Mode\n\
==============================\n\
\n\
These keys configure Dinotrace Mode:\n\
"
"\n\
`C-x C-a a'\n\
`M-x dinotrace-hierarchy-set'\n\
     `C-x C-a a' will specify the hierarchy as a regular expression.\n\
     Any signals must match this regular expression in order to be\n\
     annotated.  This is useful if the same signal name appears in many\n\
     modules with different values; you can thus choose which modules\n\
     the signals will come from.\n\
\n\
\n\
9.7 Keys in Dinotrace Mode\n\
==========================\n\
\n\
When inside a Dinotrace Mode buffer, many keys are defined to affect\n\
both Emacs and also Dinotrace.  All begin with `C-x C-a', and are also\n\
selectable from the Emacs menubar.  Most match the keyboard accelerator\n\
keys for Dinotrace itself.\n\
\n\
`C-x C-a c'\n\
`M-x dinotrace-goto-and-cursor-time'\n\
     Take the time that the point is over, and scroll Dinotrace so time\n\
     is visible.  Add a cursor using the current color.\n\
\n\
`C-x C-a C'\n\
`M-x dinotrace-goto-and-cursor-time-next-color'\n\
     Take the time that the point is over, and scroll Dinotrace so time\n\
     is visible.  Add a cursor using the next color.\n\
\n\
`C-x C-a s'\n\
`M-x dinotrace-goto-and-highlight-signal'\n\
     `C-x C-a s' will take the signal name the point is over, and scroll\n\
"
"     Dinotrace so the signal is visible.  The signal is highlighted\n\
     using the current color.\n\
\n\
`C-x C-a S'\n\
`M-x dinotrace-goto-and-highlight-signal-next-color'\n\
     `C-x C-a S' will take the signal name the point is over, and scroll\n\
     Dinotrace so the signal is visible.  The signal is highlighted\n\
     using the next color.\n\
\n\
`C-x C-a v'\n\
`M-x dinotrace-highlight-value'\n\
     `C-x C-a v' will take the value the point is over, and highlight it\n\
     using the current color.  With a prefix-arg, cursors will also be\n\
     put where the value occurs.\n\
\n\
`C-x C-a V'\n\
`M-x dinotrace-highlight-value-next-color'\n\
     `C-x C-a S' will take the value the point is over, and highlight it\n\
     using the next color.  With a prefix-arg, cursors will also be put\n\
     where the value occurs.\n\
\n\
`C-x C-a >'\n\
`M-x dinotrace-cursor-step-forward'\n\
     `C-x C-a >' will move all cursors forward one grid #0 period and\n\
     reannotate the buffer.  If the grid is set correctly, this will\n\
     change the values to represent one clock period later.\n\
\n\
`C-x C-a <'\n\
`M-x dinotrace-cursor-step-backward'\n\
     `C-x C-a <' will move all cursors back one grid #0 period and\n\
     reannotate the buffer.  If the grid is set correctly, this will\n\
"
"     change the values to represent one clock period earlier.\n\
\n\
\n\
10 File Formats\n\
***************\n\
\n\
This chapter describes the file formats supported by Dinotrace, and how\n\
to produce them with various simulators.\n\
\n\
  If you're making a quick trace that is small, the ASCII format is\n\
probably quickest and dirtiest.  If you're making a real 4-state\n\
simulator, Tempest XOR format is very compact and fast.  A example\n\
reader for this format is included with the Dinotrace distribution.\n\
\n\
10.1 Verilog Value Change Dumps\n\
===============================\n\
\n\
Dinotrace can read the Value Change Dump format, common with simulators\n\
such as Verilog-XL, VCS, and many others.\n\
\n\
  VCD files have a `.vcd' extension.  Under the `Trace Read' menu,\n\
select Verilog Format.  Select `Trace Read' to read the file.  If this\n\
is your standard format, you can set it permanently by placing in the\n\
`$DINODISK:dinotrace.dino' file:\n\
\n\
     file_format verilog\n\
     vector_separator \"[\"\n\
\n\
  VCD files can contain a great number of signals, potentially every net\n\
in the design.  To cut down on the clutter, Dinotrace removes any signal\n\
that is identical to a signal higher up in the design hierarchy.  For\n\
"
"example, if the signal `top.cpu.cache.index_addr[7:0]' is the same net\n\
as `top.cpu.addr[27:20]', then only the latter will be shown in\n\
Dinotrace.  This can be disabled with `save_duplicates'.\n\
\n\
  To save disk space you may wish to store files as gziped.  This will\n\
result in about a 10 times space savings, and Dinotrace will uncompress\n\
them automatically.  (By detecting the `.gz' extension and piping\n\
through gunzip.  Gunzip must exist in your `$PATH' for this to work.)\n\
\n\
10.1.1 Making VCDs in Verilog\n\
-----------------------------\n\
\n\
To create a value change dump file inside of Verilog, add the code\n\
somewhere in a module:\n\
\n\
     // Create a dump file\n\
     initial begin\n\
             $dumpfile (\"|gzip --fast --stdout >trace_top.vcd.gz\");\n\
             $dumpvars (12, top);\n\
     end\n\
\n\
  Where top is the name of the module to be traced, trace_top.vcd.gz is\n\
the output file, and 12 is the number of levels of hierarchy underneath\n\
top to be traced.  Dinotrace expects the `.vcd' extension.  This\n\
command will dump all signals in the module top.  For more information\n\
on dump files, see `Chapter 18 of the Verilog-XL reference manual'.\n\
\n\
10.1.2 VCD File Format\n\
----------------------\n\
\n\
For a description of the VCD file format, see `Chapter 18 of the\n\
"
"Verilog-XL reference manual'.\n\
\n\
10.2 Verilog Value Plus Dumps\n\
=============================\n\
\n\
Dinotrace can read the Value Plus Dump format, common with VCS.\n\
\n\
  VPD files have a `.vpd' extension.  Under the `Trace Read' menu,\n\
select Verilog VPD Format.  Select `Trace Read' to read the file.  If\n\
this is your standard format, you can set it permanently by placing in\n\
the `$DINODISK:dinotrace.dino' file:\n\
\n\
     file_format vpd\n\
     vector_separator \"[\"\n\
\n\
  For this to work, you must have the *vpd2vcd* program installed in\n\
your search path.  It was distributed with VCS, and requires a key to\n\
operate; contact your simulation vendor for details.\n\
\n\
  Dinotrace will convert the format to a standard VCD file using a pipe.\n\
Thus all of the notes above for the *note Verilog Value Change Dumps::\n\
also apply to this format.\n\
\n\
10.2.1 Making VPDs in Verilog\n\
-----------------------------\n\
\n\
To create a value plus dump file inside of Verilog, add the code\n\
somewhere in a module:\n\
\n\
     // Create a vpd file\n\
     initial begin\n\
"
"             $vcdpluson (12, top);\n\
     end\n\
\n\
  Where top is the name of the module to be traced, and 12 is the number\n\
of levels of hierarchy underneath top to be traced.  For this to work\n\
you may also need a `-I' or other compile time option for your\n\
simulator.\n\
\n\
10.3 ASCII Traces\n\
=================\n\
\n\
The initial format that Dinotrace supported was a Decsim ASCII format.\n\
This format is still very useful for reading traces created by *perl*\n\
scripts and other quick programs.  For large traces, any of the other\n\
formats will make significantly smaller files.\n\
\n\
10.3.1 Making Decsim ASCII Traces\n\
---------------------------------\n\
\n\
Decsim provides both ASCII and binary formats.  For a Decsim ASCII\n\
trace, type at the command prompt:\n\
\n\
     set trace/radix=2/vector/header/exact/logname=name\n\
     	clock, signal1, signal2, signal3\n\
\n\
  For information, see *note Making Decsim Binary Traces::.\n\
\n\
10.3.2 ASCII Trace Format\n\
-------------------------\n\
\n\
The ASCII Trace format is broken into two pieces, the header, and the\n\
"
"data lines.\n\
\n\
  The header consists of a leading !, followed by signal names that are\n\
read vertically, with each bit in a independent column.  Some character\n\
separates the signal name from the bit number, this exact character\n\
varies depending on the simulator.  The header is actually optional,\n\
Dinotrace will create some pretty boring names if the header is not\n\
present.\n\
\n\
  Here's a header, with the signal names SIG[2:0] and OUT.  (Read it\n\
sideways.)\n\
\n\
     !     SSS\n\
     !     III\n\
     !     GGGO\n\
     !     ___U\n\
     !     210T\n\
\n\
  The data follows, with one time per line.  The spaces leading the\n\
header above were added so that the first signal column lines up with\n\
the first value after the time stamp.  Actually, the time stamps are\n\
optional, in which case Dinotrace will assign successive times,\n\
starting at 0 and incrementing by 100 for each data line.\n\
\n\
     0     xxxx\n\
     100   000x\n\
     103   0000\n\
     200   1100\n\
     203   0001\n\
\n\
  Dinotrace understands the values `0', `1', the tristate `Z', and the\n\
"
"unknowns `?', `X', and `U'.  Case does not matter.\n\
\n\
10.4 Tempest Traces\n\
===================\n\
\n\
Dinotrace supports Digital's tempest (BT02) format, as produced by CCLI,\n\
COSMOS and other tools.  After creating a trace, start up Dinotrace.\n\
Under the `Trace Read' menu section, select _Tempest Format_.  (To make\n\
this the default, read the instructions about configuration files.)\n\
Select `Trace Read' to read the file.\n\
\n\
  Tempest designs use underscores to indicate bus subscripts.  To have\n\
Dinotrace collapse signals into vectors, create a configuration file\n\
with the lines:\n\
\n\
     vector_separator \"<\"\n\
     hierarchy_separator \">\"\n\
\n\
  Some CPU groups use a timestamp that is a integer that increases every\n\
other cycle.  The half cycle is a phase.  Dinotrace can either count\n\
phases, which is the default, or cycles.  Since Dinotrace times are\n\
integers, the trick is to change the time resolution so that fractional\n\
values can be displayed:\n\
\n\
     time_multiplier 500\n\
     time_precision ps\n\
     time_rep ns\n\
\n\
  To detect traces that start on phase B, the second signal in the\n\
trace, right after the cycle_count, must be \"phase\", which toggles\n\
zero/one every phase.  If this signal is not present, it is assumed the\n\
"
"trace starts on phase A.  (If incorrect - it starts on phase B and\n\
there is no phase signal, the first phase in the entire trace will seem\n\
to be stretched one cycle.)\n\
\n\
  To save disk space you may wish to store files as gziped.  This will\n\
result in about a 50 times space savings, and Dinotrace will uncompress\n\
them automatically.\n\
\n\
10.5 Making Verilator Traces\n\
============================\n\
\n\
Dinotrace can read in Verilator traces created using CCLI.  Dinotrace\n\
will convert the two signals that Verilator creates for tristate busses\n\
(foo and foo__en) into a single signal with tristates shown normally.\n\
\n\
10.6 Making Cosmos Traces\n\
=========================\n\
\n\
Dinotrace can read in COSMOS traces created under Merlin.  Dinotrace\n\
will convert the two signals that COSMOS creates for each signal (foo\n\
and foo__cos) into a single signal with unknowns shown normally.\n\
\n\
10.7 Tempest Trace Format\n\
=========================\n\
\n\
The Tempest Trace Format is a relatively simple binary format.  Files\n\
all have a `.bt' extension, and are stored by unix `write()'s of arrays\n\
of *little-endian* longwords.  (Little is the endianness as Windows NT\n\
and Digital Unix, and opposite that of Suns.)\n\
\n\
  The first record is at the head of the file, and is the identification\n\
"
"block.\n\
\n\
`char (4 bytes)'\n\
     File signature plus revision (e.g. `BT02').\n\
\n\
`uint (32 bits)'\n\
     Number of bytes for the header.\n\
\n\
`uint (32 bits)'\n\
     Number of signals.\n\
\n\
`uint (32 bits)'\n\
     Number of simulation rows (Do not rely on this, it is not correct\n\
     if not known when the header is written)\n\
\n\
`uint (32 bits)'\n\
     Number of bits per simulation 'row', non-padded.\n\
\n\
`uint (32 bits)'\n\
     Number of bits per simulation 'row', padded to mod 64.\n\
\n\
  Following that is a signal description block for every signal in the\n\
design.  The number of such records was read from the above\n\
identification block.\n\
\n\
`uint (32 bits)'\n\
     Flags for signal characteristics:\n\
    `bit 0'\n\
          Signal is input.\n\
\n\
    `bit 1'\n\
"
"          Signal is output.\n\
\n\
    `bit 2'\n\
          Signal is pseudo-pin.\n\
\n\
    `bit 3'\n\
          Signal contains time-stamp value (not a real signal in\n\
          design).\n\
\n\
    `bit 4'\n\
          Signal is 3 or 4 state (not 2 state).\n\
\n\
`uint (32 bits)'\n\
     Offset in body row (in bits).\n\
\n\
`uint (32 bits)'\n\
     Width of signal (in bits).\n\
\n\
`uint (32 bits)'\n\
     Number of chars in signal name.  N below.\n\
\n\
`char (N bytes)'\n\
     Signal name, not null terminated.\n\
\n\
`char padding (8-(N%(8 bytes))) if N%8 != 0'\n\
     Padding characters to insure quadword alignment.\n\
\n\
  Finally is binary packed data.  Each simulation row contains the value\n\
of all signals at that time stamp.  The location of each bit was defined\n\
in the signal description blocks above.  For example, storage of 300\n\
signals requires 320 bits per row of simulation data.  This data\n\
"
"continues to EOF.  (The number of simulation rows in the header may not\n\
be correct if it was unknown at the time the header was written.)\n\
\n\
  For three and four state signals, the four state bit in the flag\n\
section is set for that signal.  Two bits are stored in the file per\n\
wire bit, where 00=0, 01=1, 10=tristate, and 11=unknown.\n\
\n\
10.8 Tempest XOR Traces\n\
=======================\n\
\n\
Dinotrace and Verilator have colluded to make a derivative of the\n\
Tempest format, called XOR format (format string BX02).  This format is\n\
detected by Dinotrace automatically when tempest format is selected.\n\
\n\
  Ungziped files are only slightly smaller than as traditional Tempest\n\
files.  Gziping however yields a 90% shrink in file size.  Since the\n\
code to generate the trace is compiled in, the actual simulation time to\n\
create the trace is also greatly reduced, speeding simulations by 30% or\n\
so.\n\
\n\
10.9 Making Verilator XOR Traces\n\
================================\n\
\n\
Verilator makes Tempest XOR traces using the fast trace *perl* script\n\
(see the `Verilator Manual').  A list of signals to be traced must be\n\
provided at compile time.\n\
\n\
10.10 Tempest XOR Format\n\
========================\n\
\n\
Tempest XOR format is very close to tempest normal format.  The first\n\
"
"difference is that the format characters are BX02 rather than BT02.\n\
\n\
  The second difference is that the binary data for each time record is\n\
a XOR of the previous row's binary data.  (Starting with all zeros\n\
before the first record.)  Thus if a single signal changes in a given\n\
time, the first longword will have a couple of bits set to indicate the\n\
bits that changed in the time stamp, and a single bit will be set in a\n\
later longword for the bit that changed.\n\
\n\
  This seemingly trivial change greatly improves compression, as 0's are\n\
now the majority of the file, and compress to near nothing.\n\
\n\
  Any Tempest XOR format readers and writers should only operate on\n\
gziped files.  Thus the normal file extension is `.bt.gz'.\n\
\n\
10.11 Decsim Binary\n\
===================\n\
\n\
The Digital internal Decsim simulator has a proprietary format supported\n\
by Dinotrace built under VMS only.\n\
\n\
  Decsim designs use <>'s to indicate bus subscripts.  To have Dinotrace\n\
collapse signals into vectors, create a configuration file with the\n\
line: `vector_separator \"<\"'.\n\
\n\
10.11.1 Making Decsim Binary Traces\n\
-----------------------------------\n\
\n\
Decsim uses the set trace command to create Dinotrace compatible\n\
traces.  Usually a clock should be the first signal as Dinotrace will\n\
automatically align the grid to the first signal in a trace.\n\
"
"\n\
  At the command prompt, type:\n\
\n\
     set trace/radix=2/vector/binary/exact/logname=name\n\
     	clock, signal1, signal2, signal3\n\
\n\
  Our group creates a trace file for each sub chip, and turns that\n\
trace into a macro in a separate file.  This way the same trace may be\n\
called from many tests. For example:\n\
\n\
  `TRACE_subchip.IND':\n\
     macro/command TRACE_subchip [$text] =\n\
     set trace/radix=2/vector/binary/exact/logname=$text\n\
     	clock,\n\
     	signal1,\n\
     	signal2\n\
     $endmacro\n\
\n\
  A test would then call:\n\
     @TRACE_subchip.IND\n\
     TRACE_subchip testname_subchip\n\
\n\
  The test will create a file testname_subchip.TRA.  We find this naming\n\
convention convenient as it will group all of the traces from one chip\n\
together.  For example, running the test `ERRORS' with the trace files\n\
`TRACE_SSM.IND' and `TRACE_CSR.IND' creates the trace files\n\
`ERRORS_SSM.TRA' and `ERRORS_CSR.TRA'.\n\
\n\
11 Bugs\n\
*******\n\
\n\
"
"This chapter describes bug reporting and the known bugs in the current\n\
version.\n\
\n\
  Please report bugs to <wsnyder@wsnyder.org>\n\
\n\
  The following bugs are known to exist:\n\
\n\
   * When using *lessTIF*, the lines indicating highlighted signals and\n\
     cursors that appear in the scroll bars may not always appear.  To\n\
     make them reappear, simply press the refresh widget.\n\
\n\
   * The Ultrix version of Dinotrace requires *Motif V1.1.3*.  It will\n\
     run under older versions, however toolkit warnings will be printed\n\
     which may be ignored and Trace Open will make the window size too\n\
     large.\n\
\n\
   * Decsim does not correctly create binary traces of arrays.  For\n\
     example `signal[1:0]<1:0>' will not display the correct data in\n\
     Dinotrace because Decsim incorrectly creates the file.  Decsim will\n\
     work correctly if the trace is changed to ASCII.\n\
\n\
   * There is a problem with the *X-11* Toolkit that causes strange dots\n\
     to appear in the trace window.  This only occurs on some systems.\n\
     Please contact me if this occurs on your systems.\n\
\n\
\n\
";

